// TrafficLightsCanvas.cpp : implementation file
//

#include "stdafx.h"
#include "TrafficLightsCanvas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTrafficLightsCanvas

CTrafficLightsCanvas::CTrafficLightsCanvas()
{
	m_ColorBg		= RGB(255, 255, 200);
	m_ColorYellow	= RGB(255, 255, 0);
	m_ColorRed		= RGB(255, 0, 0);
	m_ColorGreen	= RGB(0, 255, 0);
	m_ColorOff		= RGB(200, 200, 200);
	m_ColorMain		= RGB(0, 0, 0);
	mode = OFF;
	modenxt = OFF;
	timerid = 0;
}

CTrafficLightsCanvas::~CTrafficLightsCanvas()
{
}


BEGIN_MESSAGE_MAP(CTrafficLightsCanvas, CWnd)
	//{{AFX_MSG_MAP(CTrafficLightsCanvas)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTrafficLightsCanvas message handlers

BOOL CTrafficLightsCanvas::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), ::CreateSolidBrush(m_ColorBg), NULL);
	cs.x = 10;
	cs.y = 10;
	cs.cx =	150;
	cs.cy = 250;

	return CWnd::PreCreateWindow(cs);
}

void CTrafficLightsCanvas::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CRect rect;
	GetClientRect(&rect);
	int y = 30;
	int x = rect.right / 2;
	int btw = 10;
	int r = 20;
	int step = 2*r + btw;

	CRect rectRed = CRect(x-r,y,x+r,y+2*r);
	CRect rectGreen = CRect(x-r,y+2*step,x+r,y+2*step+2*r);
	CRect rectYellow = CRect(x-r,y+step,x+r,y+step+2*r);

	dc.SelectObject(&m_MainPen);
	dc.SelectObject(&m_BrushOff);
	dc.MoveTo(x,y);
	dc.LineTo(x,y+3*step+3*btw);
	dc.MoveTo(x-5,y+3*step+3*btw);
	dc.LineTo(x+5,y+3*step+3*btw);

	dc.Ellipse(rectGreen);
	dc.Ellipse(rectYellow);
	dc.Ellipse(rectRed);

	switch(mode)
	{
	case OFF:		if(modenxt == GREEN)
						mode = BLINKGREEN;
					else if(modenxt == YELLOW)
						mode = BLINKYELLOW;
					else
						mode = OFF;
					break;
	case RED:		dc.SelectObject(&m_BrushRed);
					dc.Ellipse(rectRed);
					break;
	case GREEN:		dc.SelectObject(&m_BrushGreen);
					dc.Ellipse(rectGreen);
					break;
	case YELLOW:	dc.SelectObject(&m_BrushYellow);
					dc.Ellipse(rectYellow);
					break;
	case REDYELLOW: dc.SelectObject(&m_BrushYellow);
					dc.Ellipse(rectYellow);
					dc.SelectObject(&m_BrushRed);
					dc.Ellipse(rectRed);
					break;
	case BLINKGREEN:dc.SelectObject(&m_BrushGreen);
					dc.Ellipse(rectGreen);
					mode = OFF;
					modenxt = GREEN;
					timerid = SetTimer(1, 400, NULL);
					break;
	case BLINKYELLOW:dc.SelectObject(&m_BrushYellow);
					dc.Ellipse(rectYellow);
					mode = OFF;
					modenxt = YELLOW;
					timerid = SetTimer(1, 400, NULL);
					break;
	default:		break;
	}

	
	// Do not call CWnd::OnPaint() for painting messages
}

void CTrafficLightsCanvas::SetMode(states _mode)
{
	mode = _mode;
	if(timerid)
		KillTimer(timerid);
	timerid = 0;
	RedrawWindow();
}

int CTrafficLightsCanvas::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	m_MainPen.CreatePen(PS_SOLID, 1, m_ColorMain);
	
	m_BrushYellow.CreateSolidBrush(m_ColorYellow);
	m_BrushRed.CreateSolidBrush(m_ColorRed);
	m_BrushGreen.CreateSolidBrush(m_ColorGreen);
	m_BrushOff.CreateSolidBrush(m_ColorOff);

	return 0;
}

void CTrafficLightsCanvas::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CWnd::OnTimer(nIDEvent);
	RedrawWindow();
}
